#!/usr/bin/perl -w
#use strict;
use warnings;
use Glib qw( TRUE FALSE );
use Glib ':constants';
use Gtk2 '-init';
#use Gtk2 -init;
use Gnome2::Canvas;
my $ejex = 200.0;
my $encendido = Gtk2::Gdk::Pixbuf->new_from_file_at_scale("encendido.gif",50,50,TRUE);
my $apagado = Gtk2::Gdk::Pixbuf->new_from_file_at_scale("apagado.gif",50,50,TRUE);
my $band = 0;

 sub _init {
	
    $ventana = crear_ventana();
    $botones = crear_botones();
    $frame = crear_frame();
    $scroller = Gtk2::ScrolledWindow->new;
    $canvas = Gnome2::Canvas->new;
    $root = $canvas->root;
    $scroller->add ($canvas);
    $canvas->set_scroll_region (0, 0, 800, 600);
    $frame->add($scroller);

   my $hbox =Gtk2::HBox->new(0,0);
    $hbox->pack_start($botones,FALSE,FALSE,2);
    $hbox->pack_start($frame,TRUE,TRUE,2);
$vbox = Gtk2::VBox->new( FALSE, 0 );
$vbox->pack_start( Gtk2::HSeparator->new, FALSE, FALSE, 0 );
$vbox->pack_end($hbox,TRUE,TRUE,0);

   $ventana->add( $vbox );
    $ventana->show_all;
    return;
}

sub crear_ventana {
    my $ventana = Gtk2::Window->new( 'toplevel' );
    $ventana->set_title('PRUEBA');
    $ventana->set_border_width( 4 );
    $ventana->set_default_size( 800, 600 );
    $ventana->signal_connect( destroy => sub{ Gtk2->main_quit } );
    return $ventana;
}

sub crear_botones {

   my $vbox = Gtk2::VBox->new( FALSE, 0 );

    $b_add=Gtk2::Button->new("AADIR_ITEM");
    $b_add->signal_connect( clicked => \&add_item );
    $vbox->pack_start($b_add,FALSE,FALSE,2);

    $b_toogle=Gtk2::ToggleButton->new_with_mnemonic("dibujar");
    $b_toogle->signal_connect(clicked => \&toogle_activation);
    $vbox->pack_start($b_toogle,FALSE,FALSE,2);

    return $vbox;
}

sub crear_frame {

    $frame = Gtk2::Frame->new('RESULTADOS');
    $frame->set_label_align(1,2);
$frame->set_shadow_type('in');
return $frame;
}
sub add_item {
	
	my $item = Gnome2::Canvas::Item->new($root,'Gnome2::Canvas::Pixbuf',
							pixbuf => $encendido,
							x      => $ejex,
							y      => 100,
						width  => $encendido->get_width,
						height => $encendido->get_height,
							anchor => 'center',
						);
$ejex = $ejex + 100;
$item->signal_connect(event => \&item_event);
}
my $dragging = FALSE;
my ($x, $y);

sub item_event {

	my ($item, $event) = @_;
	# set item_[xy] to the event x,y position in the parent's
	# item-relative coordinates
	my ($item_x, $item_y) = $item->parent->w2i ($event->coords);
	
	if ($event->type eq 'button-press') {
		if ($event->button == 1) {
			if ($event->state >= 'shift-mask') {
				$item->destroy;
			} else {
				$x = $item_x;
				$y = $item_y;

				$item->grab ([qw/pointer-motion-mask
				                 button-release-mask/],
				             Gtk2::Gdk::Cursor->new ('fleur'),
				            $event->time);

				$dragging = TRUE;
			}
		} elsif ($event->button == 2) {

			if ($event->state >= 'shift-mask') {
				$item->lower_to_bottom;
			} else {
				$item->lower (1);
			}

		} elsif ($event->button == 3) {

			if ($event->state >= 'shift-mask') {
				$item->raise_to_top;
			} else {
				$item->raise (1);
			}
		}

	} elsif ($event->type eq 'motion-notify') {
		if ($dragging && $event->state >= 'button1-mask') {
			my $new_x = $item_x;
			my $new_y = $item_y;

			$item->move ($new_x - $x, $new_y - $y);
			$x = $new_x;
			$y = $new_y;
		}

	} elsif ($event->type eq 'button-release') {
		$item->ungrab	 ($event->time);
		$dragging = TRUE
;
	} 
	
return FALSE;
}

sub toogle_activation{

	my $button = shift;
	if ($button->get_active) {
		$canvas->signal_connect(event => \&event_mouse);
	} else{ 
		$canvas->signal_disconnect(event => \&event_mouse);
		}
}

my $drag=FALSE;
my ($lx1,$ly1,$lx2,$ly2);

sub event_mouse {
	my ($can,$event) = @_;
#	my ($item_x, $item_y) = $item->parent->w2i ($event->coords);

	if ($event->type eq 'button-press') {
		if ($event->button == 1) {
			if($band==0) {
				$lx1 = $event->x;
				$ly1 = $event->y;
				$band = 1;
				}
			else {
				$lx2 = $event->x;
				$ly2 = $event->y;
				$band = 0;
my $item = Gnome2::Canvas::Item->new ($root, 'Gnome2::Canvas::Line',
					      points => [$lx1, $ly1, $lx2, $ly2],
					      fill_color => 'black',
					      first_arrowhead => TRUE,
					      last_arrowhead => TRUE);
$drag=TRUE;
			
			} 
		}
	}	
	
		
}
_init;
Gtk2->main;

